/*
 * base.h - Basic definitions, types
 *
 *   Copyright (c) 2008  Takanori Ishikawa  <takanori.ishikawa@gmail.com>
 *
 *   Permission is hereby granted, free of charge, to any person obtaining a copy
 *   of this software and associated documentation files (the "Software"), to deal
 *   in the Software without restriction, including without limitation the rights
 *   to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *   copies of the Software, and to permit persons to whom the Software is
 *   furnished to do so, subject to the following conditions:
 *
 *   The above copyright notice and this permission notice shall be included in
 *   all copies or substantial portions of the Software.
 *
 *   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *   OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *   THE SOFTWARE.
 */

#ifndef DOLLAR_BASE_H
#define DOLLAR_BASE_H


/* ----------------------------------------------------------------
 * Standard Library Headers
 * ---------------------------------------------------------------- */
#ifdef __cplusplus
# include <cstddef>
# include <cmath>
#else /* __cplusplus */
# include <stddef.h>
# include <math.h>
#endif /* __cplusplus */


/* ----------------------------------------------------------------
 * inline, extern
 * ---------------------------------------------------------------- */
/* Inline Functions in C */
#if !defined(GR_INLINE)
# if defined(__STDC_VERSION__) && __STDC_VERSION__ >= 199901L
#   define GR_INLINE static inline
# elif defined(__MWERKS__) || defined(__cplusplus)
#   define GR_INLINE static inline
# elif defined(__GNUC__)
#   define GR_INLINE static __inline__
# else
#   define GR_INLINE static
# endif
#endif /* !defined(GR_INLINE) */

/* External Functions in C */
#if !defined(GR_EXTERN)
# define GR_EXTERN extern
#endif /* !defined(GR_EXTERN) */


/* ----------------------------------------------------------------
 * Useful macros
 * ---------------------------------------------------------------- */
#ifndef M_PI
# define M_PI   3.14159265358979323846   /* pi */
#endif /* M_PI */

#ifndef M_PI_2
# define M_PI_2 1.57079632679489661923   /* pi/2 */
#endif /* M_PI_2 */


#endif /* DOLLAR_BASE_H */
